' (c) 2022 cepstrum.co.jp 
'
' FreeBASIC console program
' >fbc -s console

#include "portaudio.bi"
#include "windows.bi"
#include "string.bi"

dim asio_api_index        as integer
dim host_api_count        as integer
dim device_count          as integer
dim device_index          as integer
dim host_api_info         as PaHostApiInfo ptr
dim device_info           as PaDeviceInfo  ptr
dim min_buffer_size       as long
dim max_buffer_size       as long
dim preferred_buffer_size as long
dim granularity           as long
dim strbuf                as zstring * 512
dim i                     as integer

'=====================================================================

sub device2name(device_index as integer, byref strbuf as zstring ptr) 
  dim device_info as PaDeviceInfo ptr
  dim wstrbuf     as wstring * 512

  device_info=Pa_GetDeviceInfo(device_index)
  MultiByteToWideChar(CP_UTF8, 0, device_info->name, -1, wstrbuf, 512)     ' --> unicode
  WideChartoMultiByte(CP_ACP, 0, @wstrbuf, 512, strbuf, 512, NULL, NULL)   ' --> shiftjis
end sub

'=====================================================================

Pa_Initialize()
asio_api_index=Pa_HostApiTypeIdToHostApiIndex(3)     ' (index val 3)= asio
host_api_info=Pa_GetHostApiInfo(asio_api_index)
print "--------------------------------------------------------------------"
print "PortAudio                                                buffer size"
print "device index  name                                       min/max"
print "--------------------------------------------------------------------"
for i=0 to (host_api_info->deviceCount)-1
  device_index=Pa_HostApiDeviceIndexToDeviceIndex(asio_api_index, i)
  device_info=Pa_GetDeviceInfo(device_index)
  PaAsio_GetAvailableBufferSizes(device_index, @min_buffer_size, @max_buffer_size, @preferred_buffer_size, @granularity)
  print using "##            "; device_index;
  device2name(device_index, @strbuf) 
  print strbuf; space(43-len(strbuf));
  print format(min_buffer_size); "/"; format(max_buffer_size)
next
print "--------------------------------------------------------------------"

Pa_Terminate()

locate , , 0                                ' hide cursor
print "hit any key to exit                          (c) 2022 cepstrum.co.jp";
getkey
locate , , 1                                ' show cursor
