' (c) 2022 cepstrum.co.jp 
'
' FreeBASIC console program
' >fbc -s console

#include "portaudio.bi"
#include "windows.bi"

dim mme_api_index         as integer
dim asio_api_index        as integer
dim wasapi_api_index      as integer
dim wdmks_api_index       as integer
dim host_api_count        as integer
dim device_count          as integer
dim device_index          as integer
dim default_host_api_info as PaHostApiInfo ptr
dim host_api_info         as PaHostApiInfo ptr
dim device_info           as PaDeviceInfo  ptr
dim strbuf                as zstring * 512
dim i                     as integer

'=====================================================================

sub device2name(device_index as integer, byref strbuf as zstring ptr) 
  dim device_info as PaDeviceInfo ptr
  dim wstrbuf     as wstring * 512

  device_info=Pa_GetDeviceInfo(device_index)
  MultiByteToWideChar(CP_UTF8, 0, device_info->name, -1, wstrbuf, 512)     ' --> unicode
  WideChartoMultiByte(CP_ACP, 0, @wstrbuf, 512, strbuf, 512, NULL, NULL)   ' --> shiftjis
end sub

'=====================================================================

Pa_Initialize()

default_host_api_info=Pa_GetHostApiInfo(Pa_GetDefaultHostApi()) 

print "------------------------------------------------------------------"

mme_api_index=Pa_HostApiTypeIdToHostApiIndex(2)
host_api_info=Pa_GetHostApiInfo(mme_api_index)
print "[MME]"
for i=0 to (host_api_info->deviceCount)-1
  device_index=Pa_HostApiDeviceIndexToDeviceIndex(mme_api_index, i)
  device_info=Pa_GetDeviceInfo(device_index)
  print using "## "; device_index;
  if (default_host_api_info->type)=2 and (device_info->maxInputChannels)<>0 then
    if device_index=Pa_GetDefaultInputDevice() then
      print "*";
    else
      print " ";
    end if
    print "in    "; 
    device2name(device_index, @strbuf) 
    print strbuf; space(41-len(strbuf));
    print using "###.#ms"; 1000.0*(device_info->defaultLowInputLatency)
  end if
  if (default_host_api_info->type)=2 and (device_info->maxOutputChannels)<>0 then
    if device_index=Pa_GetDefaultOutputDevice() then
      print "*";
    else
      print " ";
    end if
    print "out   "; 
    device2name(device_index, @strbuf) 
    print strbuf; space(41-len(strbuf));
    print using "###.#ms"; 1000.0*(device_info->defaultLowOutputLatency)
  end if
next

print "------------------------------------------------------------------"

asio_api_index=Pa_HostApiTypeIdToHostApiIndex(3)
host_api_info=Pa_GetHostApiInfo(asio_api_index)
print "[ASIO]"
for i=0 to (host_api_info->deviceCount)-1
  device_index=Pa_HostApiDeviceIndexToDeviceIndex(asio_api_index, i)
  device_info=Pa_GetDeviceInfo(device_index)
  print using "## "; device_index;
  if (device_info->maxInputChannels)<>0 or (device_info->maxOutputChannels)<>0 then
    if (default_host_api_info->type)=3 then
      if device_index=(host_api_info->defaultInputDevice) or device_index=(host_api_info->defaultOutputDevice) then
        print "*"; 
      else
        print " ";
      end if
    end if
    print  "in/out ";
    device2name(device_index, @strbuf) 
    print strbuf; space(41-len(strbuf));
    print using "###.#ms "; 1000.0*(device_info->defaultLowInputLatency);
    print using "###.#ms"; 1000.0*(device_info->defaultLowOutputLatency)
  end if
next

print "------------------------------------------------------------------"

Pa_Terminate()

locate , , 0                                ' hide cursor
print "hit any key to exit                        (c) 2022 cepstrum.co.jp";
getkey
locate , , 1                                ' show cursor
